import { __assign } from "tslib";
import packageInfo from "./package.json";
import { NODE_REGION_CONFIG_FILE_OPTIONS, NODE_REGION_CONFIG_OPTIONS } from "@aws-sdk/config-resolver";
import { Hash } from "@aws-sdk/hash-node";
import { NODE_MAX_ATTEMPT_CONFIG_OPTIONS, NODE_RETRY_MODE_CONFIG_OPTIONS } from "@aws-sdk/middleware-retry";
import { loadConfig as loadNodeConfig } from "@aws-sdk/node-config-provider";
import { NodeHttpHandler, streamCollector } from "@aws-sdk/node-http-handler";
import { fromBase64, toBase64 } from "@aws-sdk/util-base64-node";
import { calculateBodyLength } from "@aws-sdk/util-body-length-node";
import { defaultUserAgent } from "@aws-sdk/util-user-agent-node";
import { fromUtf8, toUtf8 } from "@aws-sdk/util-utf8-node";
import { getRuntimeConfig as getSharedRuntimeConfig } from "./runtimeConfig.shared";
/**
 * @internal
 */
export var getRuntimeConfig = function (config) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    if (config === void 0) { config = {}; }
    var clientSharedValues = getSharedRuntimeConfig(config);
    return __assign(__assign(__assign({}, clientSharedValues), config), { runtime: "node", base64Decoder: (_a = config.base64Decoder) !== null && _a !== void 0 ? _a : fromBase64, base64Encoder: (_b = config.base64Encoder) !== null && _b !== void 0 ? _b : toBase64, bodyLengthChecker: (_c = config.bodyLengthChecker) !== null && _c !== void 0 ? _c : calculateBodyLength, defaultUserAgentProvider: (_d = config.defaultUserAgentProvider) !== null && _d !== void 0 ? _d : defaultUserAgent({ serviceId: clientSharedValues.serviceId, clientVersion: packageInfo.version }), maxAttempts: (_e = config.maxAttempts) !== null && _e !== void 0 ? _e : loadNodeConfig(NODE_MAX_ATTEMPT_CONFIG_OPTIONS), region: (_f = config.region) !== null && _f !== void 0 ? _f : loadNodeConfig(NODE_REGION_CONFIG_OPTIONS, NODE_REGION_CONFIG_FILE_OPTIONS), requestHandler: (_g = config.requestHandler) !== null && _g !== void 0 ? _g : new NodeHttpHandler(), retryModeProvider: (_h = config.retryModeProvider) !== null && _h !== void 0 ? _h : loadNodeConfig(NODE_RETRY_MODE_CONFIG_OPTIONS), sha256: (_j = config.sha256) !== null && _j !== void 0 ? _j : Hash.bind(null, "sha256"), streamCollector: (_k = config.streamCollector) !== null && _k !== void 0 ? _k : streamCollector, utf8Decoder: (_l = config.utf8Decoder) !== null && _l !== void 0 ? _l : fromUtf8, utf8Encoder: (_m = config.utf8Encoder) !== null && _m !== void 0 ? _m : toUtf8 });
};
//# sourceMappingURL=runtimeConfig.js.map